/* ************************************************************************** */
/*                                       _____           _                    */
/*  adddate.c                           |_   _|__  _   _| |__   ___ _   _     */
/*  | Project : librtc                    | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/07/20 14:21:41                               |___/     */
/*                                                                            */
/* ************************************************************************** */

#include <librtc/internals.h>

/*
**	rtc_adddate:
**	Adds elements of a date to a date
**	@date: pointer on date (edits it)
**	@add: elements to add
*/

void rtc_adddate(rtc_date_t *date, rtc_date_t add)
{
	// directly add to date
	date->sec += add.sec;
	date->min += add.min;
	date->hour += add.hour;
	date->day += add.day;
	date->month += add.month;
	date->year += add.year;

	// adjust date
	// seconds -> minutes
	date->min += date->sec / 60;
	date->sec %= 60;
	// minutes -> hours
	date->hour += date->min / 60;
	date->min %= 60;
	// hours -> days
	date->day += date->hour / 24;
	date->hour %= 24;
	// days -> 4 years
	date->year += 4 * (date->day / days_in_4years);
	date->day %= days_in_4years;
	// days -> years
	int leap_from_year = date->year % 4;
	//FIXME

	// don't furget to adjust wday
	rtc_adjustwday(date);
}
